/*================================================================================================*
 * Микросекундный таймер для измерения времени и отсчета таймаутов
 * Использует таймер RIT
 *================================================================================================*/

#ifndef MICROTIMER_H_
#define MICROTIMER_H_

#include "global.h"

/*================================================================================================*/
/* Преобразование микросекунд в такты RIT */
#define MICROTIMER_CLK          LPC_CLK_RITIMER
#if !(MICROTIMER_CLK % 1000000UL)
#define MICROTIMER_uS(us)       ((us) * (MICROTIMER_CLK / 1000000UL))
#else
#define MICROTIMER_uS(us)       (((us) * 1ULL * MICROTIMER_CLK) / 1000000UL)
#endif

#define MICROTIMER_MAX_uS       (0xFFFFFFFFUL / MICROTIMER_uS(1))
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
static inline void microtimer_init      /* Инициализация таймера */
    (void)
    {
    LPC_RITIMER->CTRL = (0 & RIT_CTRL_ENCLR) | RIT_CTRL_ENBR | RIT_CTRL_TEN;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
static inline uint32_t microtimer_now   /* Чтение текущего счетчика */
    (void)
    {
    return LPC_RITIMER->COUNTER;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
static inline uint32_t microtimer_since /* Вычисление времени с момента mark в тактах RIT */
    (uint32_t mark)
    {
    return LPC_RITIMER->COUNTER - mark;
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
#endif /* MICROTIMER_H_ */
